<template>
	<b-container class="w-50 full-height">
		<b-row class="h-100 align-items-center">
			<b-col>
				<b-card header="Register" header-tag="h3">
					<b-form @submit.prevent="register">
						<b-form-group
							id="first-name-grp"
							label="First name"
							label-for="first-name">
							<b-form-input
								required
								id="first-name"
								v-model="credentials.first_name"
								autocomplete="first-name"
								:disabled="busy"/>
						</b-form-group>
						<b-form-group
							id="last-name-grp"
							label="Last name"
							label-for="last-name">
							<b-form-input
								required
								id="last-name"
								v-model="credentials.last_name"
								autocomplete="last-name"
								:disabled="busy"/>
						</b-form-group>
						<hr/>
						<b-form-group
							id="username-grp"
							description="Your username without &quot;@&quot;"
							label="Username"
							label-for="username">
							<b-form-input
								required
								id="username"
								autocomplete="username"
								v-model="credentials.username"
								:disabled="busy"/>
						</b-form-group>
						<b-form-group
							id="password-grp"
							label="Password"
							label-for="password">
							<b-form-input
								required
								id="password"
								v-model="credentials.password"
								autocomplete="current-password"
								type="password"
								:disabled="busy"/>
						</b-form-group>
						<transition name="fade">
							<b-spinner v-if="busy" class="mt-1" variant="primary" label="Loading..."/>
						</transition>
						<b-button variant="outline-custom-dark" type="submit" class="float-right" :disabled="busy">
							Register!
						</b-button>
					</b-form>
				</b-card>
			</b-col>
		</b-row>
	</b-container>
</template>

<script>

import {errorJsonToToast,} from '@/utils';

export default {
	name: 'Register',
	data() {
		return {
			credentials: {},
			busy: false,
		};
	},
	methods: {
		register() {
			this.busy = true;
			const data = this.credentials;
			console.debug('Executing register!', data);

			this.$http.post('/register/', data, {
				headers: {
					'Authorization': undefined, // Override default if not logged in
				},
			})
				.then(r => {
					this.busy = false;
					const data = r.data;
					console.info('Successfully registered', data);
					this.$router.push('/login');
					this.$nextTick(() => {  // Render toast AFTER router push
						this.$bvToast.toast('Now log in with your credentials.', {
							title: `Successfully registered as ${data.username}`,
							variant: 'success',
						});
					});
				})
				.catch(e => {
					this.busy = false;
					console.error('Failed to register', e);
					this.$bvToast.toast(errorJsonToToast(this, e), {
						title: 'Failed to register',
						variant: 'danger',
					});
				});

		},
	},
};
</script>

<style scoped>
/*noinspection CssUnusedSymbol*/
>>> .form-control {
	transition: background-color 0.3s;
}
</style>
